
{{Propeller Speech Recognizer

  Author: Corbin Adkins (a.k.a "microcontroled")

  Version: 1.0

  Updated: 8/25/2009

  Description: The PSR can recognize any speech within it's vocal range. To use, speak in
  a monotone robot-like voice. This is easyestly used with the Demo Board. The PSR is set
  up by waiting until the 4rd light down lights up and then speaking into the microphone.
  It will light the 3rd light UP if it recognizes a voice. This light will turn off once
  it is done recording. When the light up from the recording light lights up then speak
  the same word into the microphone agian. If it does not recognize your voice then the
  top light will light up. If it DOES recognize your voice then the bottom light will
  light up. The lights can be replaced with voice activated subroutines in a program. This
  software is not guarenteed to be compatible in the same configuration as future software
  like it. To modify it for your voice, set the choke and accuracy in the CON section.
  Accuracy is how many bytes have to be matched to the previous record sample for it to
  be vailid, and choke is how large of a decimal range a byte has to be in to be added to
  the accuracy variable. You may have to spend quite some time ajusting the accuracy to
  fit your voice, the choke dosn't make much of a difference.   


}}

CON

    _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000       '80 MHz

    Samples = 5300
    AdcInputPin=8
    AdcOutputPin=9
    LeftOutputPin=10
    RightOutputPin=11

    TriggerThreshold=150

  #0, WHITE,CYAN,RED,PINK,BLUE,GREEN,YELLOW,GRAY        'Standard colors

  accuracy = 2000    '2000 works perfectly for my voice, it may have to be ajusted for higher voices.
  choke = 20


VAR

  word sound[6]
  byte rec
  
OBJ
  mic:  "dual_ADC1"     'for recording
  'text : "PC_Interface"
  tv   : "TV_Text"
  ic   : "Basic_I2C_Driver"

PUB Main|n,i,j, rnd

  ic.Initialize(ic#BootPin)
  'text.start(31,30)               'Startup Propterminal
  mic.start(9,AdcInputPin,AdcOutputPin,19,19,32,32,0,0) 'start digitizing microphone
  rec := 1
  dira[16..23]~~
  sound := 0
  tv.start(12) 'start TV Text on the demoboard basepin
  'seed random
  rnd:=cnt
  ?rnd
  n := Samples
  'Then start over, but sometimes just playback on trigger
  tv.str(string("Ready for voice sync",13)) 
  repeat
    'Waitcnt(cnt+clkfreq/2)
    WaitForTrigger
    if (((?rnd)>>4)//2)>0  '50% chance
      tv.str(string("Recieving Command....",13))
      Record(@Wav)
      tv.str(string("Begining Extraction....",13))
      Extract

PUB Extract | n, i, j, temp     

    if rec == 1
      tv.str(string("Extracting 'Right.WAV'...",13))
      repeat i from 0 to n
          temp := ic.ReadByte(ic#EEPROM, $0000 + i)
          byte[final+i] := temp
      rec := 2    
      WaitForCommand(1)
    elseif rec == 2  
      tv.str(string("Extracting 'Left.WAV'...",13))  
      repeat i from 0 to n
        temp := ic.ReadByte(ic#EEPROM, $0000 + Samples + i)
        byte[final+i] := temp
      rec := 3  
      WaitForCommand(2)
    elseif rec == 3  
      tv.str(string("Extracting 'Up.WAV'...",13)) 
      repeat i from 0 to n
        temp := ic.ReadByte(ic#EEPROM, $0000 + Samples*2 + i)
        byte[final+i] := temp
      rec := 4  
      WaitForCommand(3)
    elseif rec == 4  
      tv.str(string("Extracting 'Down.WAV'...",13))  
      repeat i from 0 to n
        temp := ic.ReadByte(ic#EEPROM, $0000 + Samples*3 + i)
        byte[final+i] := temp
      rec := 5  
      WaitForCommand(4)
    elseif rec == 5  
      tv.str(string("Extracting 'Yes.WAV'...",13))  
      repeat i from 0 to n
        temp := ic.ReadByte(ic#EEPROM, $0000 + Samples*4 + i)
        byte[final+i] := temp
      rec := 6  
      WaitForCommand(5)  
    elseif rec == 6  
      tv.str(string("Extracting 'No.WAV'...",13))  
      repeat i from 0 to n
        temp := ic.ReadByte(ic#EEPROM, $0000 + Samples*5 + i)
        byte[final+i] := temp
      rec := 7  
      WaitForCommand(6)
    elseif rec == 7  
      tv.str(string("Compareing Sound Samples....",13,"You Said:  ",13))
      if sound[1] => sound[2] and sound[3] and sound[4] and sound[5] and sound[6]
        tv.str(string("Right",13))
        repeat
          outa[16]~~
      elseif sound[2] => sound[1] and sound[3] and sound[4] and sound[5] and sound[6]
        tv.str(string("Left",13))
        repeat
          outa[17]~~
      elseif sound[3] => sound[2] and sound[1] and sound[4] and sound[5] and sound[6]
        tv.str(string("Up",13))
        repeat
          outa[18]~~
      elseif sound[4] => sound[2] and sound[3] and sound[1] and sound[5] and sound[6]
        tv.str(string("Down",13))
        repeat
          outa[19]~~
      elseif sound[5] => sound[2] and sound[3] and sound[4] and sound[1] and sound[6]
        tv.str(string("Yes",13))
        repeat
          outa[20]~~
      elseif sound[6] => sound[2] and sound[3] and sound[4] and sound[5] and sound[1]
        tv.str(string("No",13))
        repeat
          outa[21]~~              
         

PUB WaitForTrigger|i
  'wait for trigger
  repeat
    i:=mic.GetAverageA>>1
    
  until (i)=>TriggerThreshold

PUB Record(pWav)|n,i,rate,nextCnt,dcnt

  dira[18..21]~~
  rate:=8000
  dcnt:=10000 

    'Get ready for fast loop
  n:=Samples  
  n--
  i:=0

  
  'Record loop
  NextCnt:=cnt+15000 
  repeat i from 0 to n
    'dira[18..21]~~  
    'outa[18]~~
    'outa[21]~
    NextCnt+=dcnt   ' need this to be 5000 for 16KSPS   @ 80 MHz
    waitcnt(NextCnt)
    byte[pWav+i]:=mic.GetAverageA>>1
  
PUB WaitForCommand(num) :bOK | n, i, nextCnt, rate, dcnt, j, rnd, s, temp, temp2

  'seed random
  'rnd:=cnt
  '?rnd
  'tv.str(string("Repeat command",13))
  'repeat
    'WaitForTrigger
    'if (((?rnd)>>4)//2)>0  '50% chance
      'Record(@final)
      DIRA[10]~~                              'Set Right Pin to output
      DIRA[11]~~                              'Set Left Pin to output

      'Set up the counters
      CTRA:= %00110 << 26 + 0<<9 + 10         'NCO/PWM Single-Ended APIN=Pin (BPIN=0 always 0)
      CTRB:= %00110 << 26 + 0<<9 + 11         'NCO/PWM Single-Ended APIN=Pin (BPIN=0 always 0)   

      'get length
      n:=Samples'long[pWav+40]
      'get rate
      rate:=8000'long[pWav+24]
      case rate
        8000:
          dcnt:=10000
        16000:
          dcnt:=5000
        other:
          return false
      'jump over header    
      final+=44   'ignore rest of header (so you better have the right file format!)

      'tv.str(string("Comparing voice samples....",13))
      'Get ready for fast loop  
      n--
      i:=0
      NextCnt:=cnt+15000
      
      'Play loop
      repeat i from 0 to n
        NextCnt+=dcnt   ' need this to be 5000 for 16KSPS   @ 80 MHz
        waitcnt(NextCnt)
        temp2 := (byte[final+i])<<24
        temp := (byte[Wav+i])<<24
        if temp2 =< temp + choke and temp2 => temp - choke
          sound[num] += 1
        Extract      

     { if sound => accuracy
          tv.str(string("Voice Match Correct!",13))
          waitcnt(clkfreq*2 + cnt)
          'dira[16]~~
          'outa[16]~~
      else
          tv.str(string("Voice Match Incorrect.",13))
          waitcnt(clkfreq*2 + cnt)
          'dira[23]~~
          'outa[23]~~    
                         }
  
DAT

WAV   byte 0[Samples]
final byte 0[Samples]



{{
                            TERMS OF USE: MIT License

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
}}
       